package net.deliciousreya.minecraftportal.extensions

import org.bukkit.util.Vector

val ZERO = Vector(0, 0, 0)
val UP = Vector(0, 1, 0)
val MID_BLOCK = Vector(0.5, 0.5, 0.5)
val MID_BLOCK_BOTTOM = Vector(0.5, 0.0, 0.5)

operator fun Vector.plus(v:Vector):Vector {
    return this.clone().add(v)
}

operator fun Vector.minus(v:Vector):Vector {
    return this.clone().subtract(v)
}

operator fun Vector.times(n:Int):Vector {
    return this.clone().multiply(n)
}

operator fun Vector.times(n:Float):Vector {
    return this.clone().multiply(n)
}

operator fun Vector.times(n:Double):Vector {
    return this.clone().multiply(n)
}

operator fun Vector.times(v:Vector):Vector {
    return this.clone().multiply(v)
}

operator fun Vector.div(v:Vector):Vector {
    return this.clone().divide(v)
}

operator fun Vector.unaryMinus(): Vector {
    return this * -1
}